#ifndef _sw_corby_channel_h
#define _sw_corby_channel_h

/*
 * Copyright 2003 Swampwolf Technologies, Inc. All rights reserved.
 *
 *	Redistribution and use in source and binary forms, with or without modification,
 *	are permitted provided that the following conditions are met:
 *
 *		1. Redistributions of source code must retain the above copyright notice,
 *		   this list of conditions and the following disclaimer.   
 *		2. Redistributions in binary form must reproduce the above copyright notice,
 *		   this list of conditions and the following disclaimer in the documentation
 *		   and/or other materials provided with the distribution.
 *
 *	THIS SOFTWARE IS PROVIDED BY SWAMPWOLF TECHNOLOGIES, INC. ``AS IS'' AND ANY
 *	EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 *	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 *	IN NO EVENT SHALL THE HOWL PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 *	INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 *	OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 *	OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 *	OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	The views and conclusions contained in the software and documentation are those
 *	of the authors and should not be interpreted as representing official policies,
 *	either expressed or implied, of Swampwolf Technologies, Inc.
 */

#include <salt/salt.h>
#include <salt/socket.h>
#include <salt/vtypes.h>
#include <corby/corby.h>


#ifdef __cplusplus
extern "C"
{
#endif 

struct												_sw_corby_channel;
typedef struct _sw_corby_channel			*	sw_corby_channel;
struct												_sw_corby_message;
struct												_sw_corby_buffer;
struct												_sw_corby_profile;
typedef struct _sw_corby_profile			*	sw_corby_profile;
typedef struct _sw_corby_profile const	*	sw_const_corby_profile;


typedef enum _sw_corby_reply_status
{
   SW_CORBY_NO_EXCEPTION		=	0,
   SW_CORBY_SYSTEM_EXCEPTION	=	1,
   SW_CORBY_USER_EXCEPTION		=	2,
   SW_CORBY_LOCATION_FORWARD	=	3
} sw_corby_reply_status;
   

sw_result CORBY_DLL
sw_corby_channel_start_request(
							sw_corby_channel				self,
							sw_const_corby_profile		profile,
							struct _sw_corby_buffer	**	buffer,
							const sw_string				op,
							sw_ulong							oplen,
							sw_bool							reply_expected);


sw_result CORBY_DLL
sw_corby_channel_start_reply(
							sw_corby_channel				self,
							struct _sw_corby_buffer	**	buffer,
							sw_ulong							request_id,
							sw_corby_reply_status		status);


sw_result CORBY_DLL
sw_corby_channel_send(
							sw_corby_channel					self,
							struct _sw_corby_buffer		*	buffer);


sw_result CORBY_DLL
sw_corby_channel_recv(
							sw_corby_channel					self,
							struct _sw_corby_message	**	message,
                     struct _sw_corby_buffer		**	buffer,
                     sw_octet							*	endian,
                     sw_bool								block);


sw_result CORBY_DLL
sw_corby_channel_last_recv_from(
							sw_corby_channel				self,
							sw_address					*	from,
							sw_port						*	from_port);


#ifdef __cplusplus
}
#endif 


#endif
