#ifndef _corby_orb_h
#define _corby_orb_h

/*
 * Copyright 2003 Swampwolf Technologies, Inc. All rights reserved.
 *
 *	Redistribution and use in source and binary forms, with or without modification,
 *	are permitted provided that the following conditions are met:
 *
 *		1. Redistributions of source code must retain the above copyright notice,
 *		   this list of conditions and the following disclaimer.   
 *		2. Redistributions in binary form must reproduce the above copyright notice,
 *		   this list of conditions and the following disclaimer in the documentation
 *		   and/or other materials provided with the distribution.
 *
 *	THIS SOFTWARE IS PROVIDED BY SWAMPWOLF TECHNOLOGIES, INC. ``AS IS'' AND ANY
 *	EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 *	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 *	IN NO EVENT SHALL THE HOWL PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 *	INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 *	OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 *	OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 *	OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	The views and conclusions contained in the software and documentation are those
 *	of the authors and should not be interpreted as representing official policies,
 *	either expressed or implied, of Swampwolf Technologies, Inc.
 */

#include <salt/salt.h>
#include <salt/address.h>
#include <salt/socket.h>
#include <salt/vtypes.h>
#include <corby/corby.h>
#include <corby/dll.h>


#ifdef __cplusplus
extern "C"
{
#endif 


struct									_sw_corby_orb;
typedef struct _sw_corby_orb	*	sw_corby_orb;
typedef void						*	sw_corby_orb_connection_handler;
typedef void						*	sw_corby_servant;
struct									_sw_corby_object;
struct									_sw_corby_channel;
struct									_sw_corby_message;
struct									_sw_corby_buffer;

typedef struct sw_corby_orb_config
{
	sw_string	m_name;
	sw_ulong		m_tag;
	sw_string	m_host;
	sw_port		m_port;
	sw_string	m_options;
} sw_corby_orb_config;


typedef sw_result
(*sw_corby_servant_cb)(
				sw_corby_servant					servant,
				sw_salt								salt,
				sw_corby_orb						orb,
				struct _sw_corby_channel	*	channel,
				struct _sw_corby_message	*	message,
				struct _sw_corby_buffer		*	buffer,
				const sw_string					op,
				sw_ulong								op_len,
				sw_ulong								request_id,
				sw_octet								endian);


typedef sw_result
(*sw_corby_orb_connection_cb)(
				sw_corby_orb_connection_handler	handler,
				sw_salt									salt,
				sw_corby_orb							orb,
				struct _sw_corby_channel		*	channel,
				sw_socket								socket,
				sw_opaque								extra);
                                          

sw_result CORBY_DLL
sw_corby_orb_init(
				sw_corby_orb						*	self,
				sw_salt									salt,
				const sw_corby_orb_config		*	config,
            sw_corby_orb_connection_handler	handler,
            sw_corby_orb_connection_cb			cb,
            sw_opaque								extra);


sw_result CORBY_DLL
sw_corby_orb_fina(
				sw_corby_orb	self);


sw_result CORBY_DLL
sw_corby_orb_register_servant(
				sw_corby_orb					self,
				sw_corby_servant				servant,
            sw_corby_servant_cb			cb,
				const sw_string				oid,
				struct _sw_corby_object	**	object,
				const sw_string				protocol_name);


sw_result CORBY_DLL
sw_corby_orb_unregister_servant(
				sw_corby_orb		self,
				const sw_string	oid);


sw_result CORBY_DLL
sw_corby_orb_protocol_to_address(
				sw_corby_orb		self,
				const sw_string	tag,
				sw_string			addr,
				sw_port			*	port);
												

sw_result CORBY_DLL
sw_corby_orb_protocol_to_url(
				sw_corby_orb		self,
            const sw_string	tag,
				const sw_string	name,
				sw_string			url);


#ifdef __cplusplus
}
#endif 


#endif
