#ifndef _salt_address_h
#define _salt_address_h

/*
 * Copyright 2003 Swampwolf Technologies, Inc. All rights reserved.
 *
 *	Redistribution and use in source and binary forms, with or without modification,
 *	are permitted provided that the following conditions are met:
 *
 *		1. Redistributions of source code must retain the above copyright notice,
 *		   this list of conditions and the following disclaimer.   
 *		2. Redistributions in binary form must reproduce the above copyright notice,
 *		   this list of conditions and the following disclaimer in the documentation
 *		   and/or other materials provided with the distribution.
 *
 *	THIS SOFTWARE IS PROVIDED BY SWAMPWOLF TECHNOLOGIES, INC. ``AS IS'' AND ANY
 *	EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 *	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 *	IN NO EVENT SHALL THE HOWL PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 *	INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 *	OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 *	OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 *	OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	The views and conclusions contained in the software and documentation are those
 *	of the authors and should not be interpreted as representing official policies,
 *	either expressed or implied, of Swampwolf Technologies, Inc.
 */


#include <salt/salt.h>


#if defined(__cplusplus)
extern "C"
{
#endif


typedef struct _sw_address
{
	sw_ulong	m_addr;
} sw_address;

typedef sw_ulong sw_saddr;


sw_address SALT_DLL
sw_address_any();


sw_address SALT_DLL
sw_address_loopback();


sw_result SALT_DLL
sw_address_init(
				sw_address	*	self);


sw_result SALT_DLL
sw_address_init_from_saddr(
				sw_address	*	self,
				sw_saddr			saddr);


sw_result SALT_DLL
sw_address_init_from_name(
				sw_address		*	self,
				const sw_string	name);


sw_result SALT_DLL
sw_address_init_from_address(
				sw_address		*	self,
				sw_address			addr);


sw_result SALT_DLL
sw_address_init_from_this_host(
				sw_address		*	self);


sw_result SALT_DLL
sw_address_fina(
				sw_address	self);


sw_bool SALT_DLL
sw_address_is_any(
				sw_address	self);
				

sw_saddr SALT_DLL
sw_address_saddr(
				sw_address	self);


sw_string SALT_DLL
sw_address_name(
				sw_address	self,
				sw_string	name,
				sw_ulong		len);


sw_result SALT_DLL
sw_address_decompose(
				sw_address		self,
				sw_octet		*	a1,
				sw_octet		*	a2,
				sw_octet		*	a3,
				sw_octet		*	a4);


sw_bool SALT_DLL
sw_address_equals(
				sw_address	self,
				sw_address	addr);


#if defined(__cplusplus)
}
#endif


#endif
