#ifndef _sw_socket_h
#define _sw_socket_h

/*
 * Copyright 2003 Swampwolf Technologies, Inc. All rights reserved.
 *
 *	Redistribution and use in source and binary forms, with or without modification,
 *	are permitted provided that the following conditions are met:
 *
 *		1. Redistributions of source code must retain the above copyright notice,
 *		   this list of conditions and the following disclaimer.   
 *		2. Redistributions in binary form must reproduce the above copyright notice,
 *		   this list of conditions and the following disclaimer in the documentation
 *		   and/or other materials provided with the distribution.
 *
 *	THIS SOFTWARE IS PROVIDED BY SWAMPWOLF TECHNOLOGIES, INC. ``AS IS'' AND ANY
 *	EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 *	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 *	IN NO EVENT SHALL THE HOWL PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 *	INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 *	OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 *	OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 *	OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	The views and conclusions contained in the software and documentation are those
 *	of the authors and should not be interpreted as representing official policies,
 *	either expressed or implied, of Swampwolf Technologies, Inc.
 */

#include <salt/address.h>
#include <salt/vtypes.h>
#include <salt/dll.h>

#ifdef __cplusplus
extern "C"
{
#endif 


struct											_sw_socket;
typedef struct _sw_socket				*	sw_socket;
struct											_sw_socket_options;
typedef struct _sw_socket_options	*	sw_socket_options;
typedef sw_ushort								sw_port;


sw_result SALT_DLL
sw_tcp_socket_init(
				sw_socket	*	self);


sw_result SALT_DLL
sw_udp_socket_init(
				sw_socket	*	self);


sw_result SALT_DLL
sw_multicast_socket_init(
				sw_socket	*	self);
                                    
                                    
sw_result SALT_DLL
sw_socket_fina(
				sw_socket	self);


sw_result SALT_DLL
sw_socket_bind(
				sw_socket	self,
				sw_address	address,
				sw_port		port);


sw_result SALT_DLL
sw_socket_join_multicast_group(
				sw_socket	self,
				sw_address	local_address,
				sw_address	multicast_address,
				sw_ulong		ttl);


sw_result SALT_DLL
sw_socket_leave_multicast_group(
				sw_socket	self);


sw_result SALT_DLL
sw_socket_listen(
				sw_socket	self,
				sw_ulong		qsize);
                                    
                                     
sw_result SALT_DLL
sw_socket_connect(
				sw_socket	self,
				sw_address	address,
				sw_port		port);
                                    
                                    
sw_result SALT_DLL
sw_socket_accept(
				sw_socket		self,
				sw_socket	*	socket);
                                    
                           
sw_result SALT_DLL
sw_socket_send(
				sw_socket		self,
				sw_octets		buffer,
				sw_len			len);


sw_result SALT_DLL
sw_socket_sendto(
				sw_socket				self,
				sw_octets				buffer,
				sw_len					len,
				struct _sw_address	to,
				sw_port					port);

                                    
sw_result SALT_DLL
sw_socket_recv(
				sw_socket		self,
				sw_octets		buffer,
				sw_len			max,
				sw_len		*	len);


sw_result SALT_DLL
sw_socket_recvfrom(
				sw_socket					self,
				sw_octets					buffer,
				sw_len						max,
				sw_len					*	len,
				struct _sw_address	*	from,
				sw_port					*	port,
				struct _sw_address	*	dest,
				sw_ulong					*	interface_index);


sw_result SALT_DLL
sw_socket_set_blocking_mode(
				sw_socket	self,
				sw_bool		blocking_mode);
				
				
sw_long SALT_DLL
sw_socket_last_error();


sw_result SALT_DLL
sw_socket_set_options(
				sw_socket				self,
				sw_socket_options		options);
                                 

sw_address SALT_DLL
sw_socket_address(
				sw_socket	self);


sw_port SALT_DLL
sw_socket_port(
				sw_socket	self);


sw_fd SALT_DLL
sw_socket_fd(
				sw_socket	self);


sw_result SALT_DLL
sw_socket_close(
				sw_socket	self);
                                   

sw_result SALT_DLL
sw_socket_options_init(
				sw_socket_options	*	self);
                                    

sw_result SALT_DLL
sw_socket_options_fina(
				sw_socket_options	self);
                                    

sw_result SALT_DLL
sw_socket_options_set_debug(
				sw_socket_options		self,
				sw_bool					val);
                               

sw_result SALT_DLL
sw_socket_options_set_nodelay(
				sw_socket_options		self,
				sw_bool					val);
                                    
                                    
sw_result SALT_DLL
sw_socket_options_set_dontroute(
				sw_socket_options		self,
				sw_bool					val);
                                    
                             
sw_result SALT_DLL
sw_socket_options_set_keepalive(
				sw_socket_options		self,
				sw_bool					val);


sw_result SALT_DLL
sw_socket_options_set_linger(
				sw_socket_options		self,
				sw_bool					onoff,
				sw_ulong					linger);
                                    
                                    
sw_result SALT_DLL
sw_socket_options_set_reuseaddr(
				sw_socket_options		self,
				sw_bool					val);


sw_result SALT_DLL
sw_socket_options_set_rcvbuf(
				sw_socket_options		self,
				sw_ulong					val);
                                    
                                    
sw_result SALT_DLL
sw_socket_options_set_sndbuf(
				sw_socket_options		self,
				sw_ulong					val);


#ifdef __cplusplus
}
#endif 


#endif
