#ifndef _salt_verrno_h
#define _salt_verrno_h

/*
 * Copyright 2003 Swampwolf Technologies, Inc. All rights reserved.
 *
 *	Redistribution and use in source and binary forms, with or without modification,
 *	are permitted provided that the following conditions are met:
 *
 *		1. Redistributions of source code must retain the above copyright notice,
 *		   this list of conditions and the following disclaimer.   
 *		2. Redistributions in binary form must reproduce the above copyright notice,
 *		   this list of conditions and the following disclaimer in the documentation
 *		   and/or other materials provided with the distribution.
 *
 *	THIS SOFTWARE IS PROVIDED BY SWAMPWOLF TECHNOLOGIES, INC. ``AS IS'' AND ANY
 *	EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 *	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 *	IN NO EVENT SHALL THE HOWL PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 *	INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 *	OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 *	OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 *	OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	The views and conclusions contained in the software and documentation are those
 *	of the authors and should not be interpreted as representing official policies,
 *	either expressed or implied, of Swampwolf Technologies, Inc.
 */

#include <salt/vtypes.h>
#include <salt/dll.h>


#ifdef __cplusplus
extern "C"
{
#endif


sw_result SALT_DLL
sw_error(
		sw_result result);
                              
                              
sw_result SALT_DLL
sw_system_error();
                              
                              
/*
   error codes
*/
#define	SW_E_CORE_BASE					1
#define	SW_E_INIT						(SW_E_CORE_BASE) + 1
#define	SW_E_MEM							(SW_E_CORE_BASE) + 2
#define	SW_E_EOF							(SW_E_CORE_BASE) + 3
#define	SW_E_NO_IMPL					(SW_E_CORE_BASE) + 4
#define	SW_E_SOCKET_BASE				200
#define	SW_E_SOCKET_CREATE			(SW_E_SOCKET_BASE) + 1
#define	SW_E_SOCKET_BIND				(SW_E_SOCKET_BASE) + 2
#define	SW_E_SOCKET_GETSOCKNAME		(SW_E_SOCKET_BASE) + 3
#define	SW_E_SOCKET_ADD_MEMBERSHIP	(SW_E_SOCKET_BASE) + 4
#define	SW_E_SOCKET_MULTICAST_TTL	(SW_E_SOCKET_BASE) + 5
#define	SW_E_SOCKET_NO_CONNECTION	(SW_E_SOCKET_BASE) + 6
#define	SW_E_PROTOCOL_NOT_FOUND		800


#ifdef __cplusplus
}
#endif 


#endif
