#ifndef _salt_types_h
#define _salt_types_h

/*
 * Copyright 2003 Swampwolf Technologies, Inc. All rights reserved.
 *
 *	Redistribution and use in source and binary forms, with or without modification,
 *	are permitted provided that the following conditions are met:
 *
 *		1. Redistributions of source code must retain the above copyright notice,
 *		   this list of conditions and the following disclaimer.   
 *		2. Redistributions in binary form must reproduce the above copyright notice,
 *		   this list of conditions and the following disclaimer in the documentation
 *		   and/or other materials provided with the distribution.
 *
 *	THIS SOFTWARE IS PROVIDED BY SWAMPWOLF TECHNOLOGIES, INC. ``AS IS'' AND ANY
 *	EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 *	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 *	IN NO EVENT SHALL THE HOWL PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 *	INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 *	OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 *	OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 *	OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	The views and conclusions contained in the software and documentation are those
 *	of the authors and should not be interpreted as representing official policies,
 *	either expressed or implied, of Swampwolf Technologies, Inc.
 */

#if defined(__VXWORKS__)
#	include <vxworks.h>
#elif defined(WIN32)
#	include <winsock2.h>
#	include <windows.h>
#elif !defined(_WIN32_WCE) && !defined(__PALMOS__)
#	include <sys/types.h>
#endif


#ifdef __cplusplus
extern "C"
{
#endif 


typedef void				*	sw_opaque;
typedef unsigned char		sw_bool;
typedef unsigned char		sw_octet;
typedef char					sw_char;
typedef unsigned char		sw_uchar;				
typedef short					sw_short;
typedef unsigned short		sw_ushort;
typedef long					sw_long;
typedef unsigned long		sw_ulong;
typedef unsigned char	*	sw_octets;
typedef char				*	sw_string;
#if !defined(__VXWORKS__) || defined(__cplusplus)
typedef const unsigned char	*	sw_const_octets;
typedef const char				*	sw_const_string;
#else
typedef unsigned char	*	sw_const_octets;
typedef char				*	sw_const_string;
#endif
typedef sw_ulong 				sw_len;
typedef int						sw_optlen;
typedef size_t					sw_size;
typedef sw_ulong				sw_pos;
typedef int						sw_fd;
typedef unsigned char	*	sw_buffer;
typedef sw_long				sw_result;

#if defined (sun) || defined (AIX)

typedef longlong_t			sw_verylong;

#elif defined(__hpux) || defined(linux) || defined(__APPLE__)

typedef int64_t				sw_verylong;

#elif defined(WIN32)

typedef _int64					sw_verylong;
	
#endif


#define SW_FALSE		0
#define SW_TRUE		1
#define SW_OKAY		0
#define SW_TRY(EXPR)	{ sw_result result; if ((result = EXPR) != SW_OKAY) return sw_error(result); } ((void) 0)
#define SW_TRY_GOTO(EXPR)	{ if ((result = EXPR) != SW_OKAY) goto exit; } ((void) 0)

#if defined(__VXWORKS__) && !defined(__cplusplus)
#	define sw_const
#	define const
#endif

#if defined(WIN32)
#	define SW_ENDIAN			1
#elif defined(__APPLE__)
#	define SW_ENDIAN			0
#elif defined(__linux__)
#	if defined(i386)
#		define SW_ENDIAN		1
#	else
#		error "CPU unknown"
#	endif
#elif defined(__VXWORKS__)
#	if defined(_ARCH_PPC)
#		define SW_ENDIAN		0
#	else
#		error "CPU unknown"
#	endif
#elif defined(__FreeBSD__)
#	if defined(i386)
#		define SW_ENDIAN		1
#	else
#		error "CPU unknown"
#	endif
#else
#error	"CPU unknown"
#endif


#ifdef __cplusplus
}
#endif 


#endif
